%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Text = PCL_Node_Edit_Coord(Node_list, New_Reference_Coord, New_Analysis_Coord)

global fem_modify_node__nodes_modified;

% Если обе системы координат в аргументах пустые, то никаких изменений не требуется
if (isempty(New_Reference_Coord) && isempty(New_Analysis_Coord))
    Text = cell(1,1);
    Text{1} = '$ Empty arguments in function PCL_Node_Edit_Coord';
    return;
end

Node_list = unique(Node_list);

if (fem_modify_node__nodes_modified == 0)
    
    fem_modify_node__nodes_modified = 1;
    Text = cell(2,1);
    Text{1} = 'STRING fem_modify_node__nodes_modified[VIRTUAL]';
    counter = 1;
    
else
    
    Text = cell(1,1);
    counter = 0;
    
end

Node_list_string = ['Node' sprintf(' %i', sortrows(Node_list,1))];

counter = counter + 1;

if (~isempty(New_Analysis_Coord))
    if (~isempty(New_Reference_Coord))
        % Меняем систему координат анализа и референсную систему координат
        Text{counter} = ['fem_modify_nodes( "' Node_list_string '", "", "Coord ' sprintf('%i', New_Reference_Coord) '", "Coord ' sprintf('%i', New_Analysis_Coord) '", "", [0, 1, 1, 0, 0, 0, 0, 0, 0, 0], fem_modify_node__nodes_modified )'];
    else
        % Меняем систему координат анализа
        Text{counter} = ['fem_modify_nodes( "' Node_list_string '", "", "", "Coord ' sprintf('%i', New_Analysis_Coord) '", "", [0, 1, 0, 0, 0, 0, 0, 0, 0, 0], fem_modify_node__nodes_modified )'];
    end
else
    if (~isempty(New_Reference_Coord))
        % Меняем референсную систему координат
        Text{counter} = ['fem_modify_nodes( "' Node_list_string '", "", "Coord ' sprintf('%i', New_Reference_Coord) '", "", "", [0, 0, 1, 0, 0, 0, 0, 0, 0, 0], fem_modify_node__nodes_modified )'];
    end
end
